/*
 * Copyright (c) 2024 Qualcomm Innovation Center, Inc. All rights reserved.
 * SPDX-License-Identifier: BSD-3-Clause-Clear
*/

#ifndef _HAL_INT_PHY_H_
#define _HAL_INT_PHY_H_

typedef enum {
	//802.11b Rates
	HAL_PHY_RATE_11B_LONG_1_MBPS,
	HAL_PHY_RATE_11B_LONG_2_MBPS,
	HAL_PHY_RATE_11B_LONG_5_5_MBPS,
	HAL_PHY_RATE_11B_LONG_11_MBPS,
	HAL_PHY_RATE_11B_SHORT_1_MBPS,
	HAL_PHY_RATE_11B_SHORT_2_MBPS,
	HAL_PHY_RATE_11B_SHORT_5_5_MBPS,
	HAL_PHY_RATE_11B_SHORT_11_MBPS,

	//11ag rates
	HAL_PHY_RATE_11A_6_MBPS,
	HAL_PHY_RATE_11A_9_MBPS,
	HAL_PHY_RATE_11A_12_MBPS,
	HAL_PHY_RATE_11A_18_MBPS,
	HAL_PHY_RATE_11A_24_MBPS,
	HAL_PHY_RATE_11A_36_MBPS,
	HAL_PHY_RATE_11A_48_MBPS,
	HAL_PHY_RATE_11A_54_MBPS,

	//MCS Index #0-15 (20MHz) Mixed Mode
	HAL_PHY_RATE_MCS_1NSS_MM_6_5_MBPS,
	HAL_PHY_RATE_MCS_1NSS_MM_13_MBPS,
	HAL_PHY_RATE_MCS_1NSS_MM_19_5_MBPS,
	HAL_PHY_RATE_MCS_1NSS_MM_26_MBPS,
	HAL_PHY_RATE_MCS_1NSS_MM_39_MBPS,
	HAL_PHY_RATE_MCS_1NSS_MM_52_MBPS,
	HAL_PHY_RATE_MCS_1NSS_MM_58_5_MBPS,
	HAL_PHY_RATE_MCS_1NSS_MM_65_MBPS,
	HAL_PHY_RATE_MCS_1NSS_MM_SG_7_2_MBPS,
	HAL_PHY_RATE_MCS_1NSS_MM_SG_14_4_MBPS,
	HAL_PHY_RATE_MCS_1NSS_MM_SG_21_7_MBPS,
	HAL_PHY_RATE_MCS_1NSS_MM_SG_28_9_MBPS,
	HAL_PHY_RATE_MCS_1NSS_MM_SG_43_3_MBPS,
	HAL_PHY_RATE_MCS_1NSS_MM_SG_57_8_MBPS,
	HAL_PHY_RATE_MCS_1NSS_MM_SG_65_MBPS,
	HAL_PHY_RATE_MCS_1NSS_MM_SG_72_2_MBPS,
	HAL_PHY_RATE_RTT,
	NUM_HAL_PHY_RATES
} hal_phy_rates_t;


typedef enum {
	//802.11b Rates
	HAL_PHY_RATE_CODE_11B_LONG_1_MBPS = 0,
	HAL_PHY_RATE_CODE_11B_LONG_2_MBPS = 1,
	HAL_PHY_RATE_CODE_11B_LONG_5_5_MBPS = 2,
	HAL_PHY_RATE_CODE_11B_LONG_11_MBPS = 3,
	HAL_PHY_RATE_CODE_11B_SHORT_1_MBPS = 4,
	HAL_PHY_RATE_CODE_11B_SHORT_2_MBPS = 5,
	HAL_PHY_RATE_CODE_11B_SHORT_5_5_MBPS = 6,
	HAL_PHY_RATE_CODE_11B_SHORT_11_MBPS = 7,

	//11ag rates
	HAL_PHY_RATE_CODE_11A_6_MBPS = 8,
	HAL_PHY_RATE_CODE_11A_9_MBPS = 9,
	HAL_PHY_RATE_CODE_11A_12_MBPS = 10,
	HAL_PHY_RATE_CODE_11A_18_MBPS = 11,
	HAL_PHY_RATE_CODE_11A_24_MBPS = 12,
	HAL_PHY_RATE_CODE_11A_36_MBPS = 13,
	HAL_PHY_RATE_CODE_11A_48_MBPS = 14,
	HAL_PHY_RATE_CODE_11A_54_MBPS = 15,

	//MCS Index #0-15 (20MHz) Mixed Mode
	HAL_PHY_RATE_CODE_MCS_1NSS_MM_6_5_MBPS = 16,
	HAL_PHY_RATE_CODE_MCS_1NSS_MM_13_MBPS = 17,
	HAL_PHY_RATE_CODE_MCS_1NSS_MM_19_5_MBPS = 18,
	HAL_PHY_RATE_CODE_MCS_1NSS_MM_26_MBPS = 19,
	HAL_PHY_RATE_CODE_MCS_1NSS_MM_39_MBPS = 20,
	HAL_PHY_RATE_CODE_MCS_1NSS_MM_52_MBPS = 21,
	HAL_PHY_RATE_CODE_MCS_1NSS_MM_58_5_MBPS = 22,
	HAL_PHY_RATE_CODE_MCS_1NSS_MM_65_MBPS = 23,
	HAL_PHY_RATE_CODE_MCS_1NSS_MM_SG_7_2_MBPS = 24,
	HAL_PHY_RATE_CODE_MCS_1NSS_MM_SG_14_4_MBPS = 25,
	HAL_PHY_RATE_CODE_MCS_1NSS_MM_SG_21_7_MBPS = 26,
	HAL_PHY_RATE_CODE_MCS_1NSS_MM_SG_28_9_MBPS = 27,
	HAL_PHY_RATE_CODE_MCS_1NSS_MM_SG_43_3_MBPS = 28,
	HAL_PHY_RATE_CODE_MCS_1NSS_MM_SG_57_8_MBPS = 29,
	HAL_PHY_RATE_CODE_MCS_1NSS_MM_SG_65_MBPS = 30,
	HAL_PHY_RATE_CODE_MCS_1NSS_MM_SG_72_2_MBPS = 31,
	HAL_PHY_RATE_CODE_RTT = 32,

	HAL_PHY_RATE_CODE_MAX = 33	// Please ensure that this value always equals HAL_RT_IDX_MAX_RATES
} hal_phy_rate_code_t;

//802.11b Rates
#define HAL_PSDU_RATE_11B_LONG_1_MBPS				   0
#define HAL_PSDU_RATE_11B_LONG_2_MBPS				   1
#define HAL_PSDU_RATE_11B_SHORT_2_MBPS			       1
#define HAL_PSDU_RATE_11B_LONG_5_5_MBPS			       2
#define HAL_PSDU_RATE_11B_SHORT_5_5_MBPS		       2
#define HAL_PSDU_RATE_11B_LONG_11_MBPS			       3
#define HAL_PSDU_RATE_11B_SHORT_11_MBPS			       3

//Spica_Virgo 11A 20MHz Rates                   //psdu rate codes
#define HAL_PSDU_RATE_11A_6_MBPS                  11
#define HAL_PSDU_RATE_11A_9_MBPS                  15
#define HAL_PSDU_RATE_11A_12_MBPS                 10
#define HAL_PSDU_RATE_11A_18_MBPS                 14
#define HAL_PSDU_RATE_11A_24_MBPS                 9
#define HAL_PSDU_RATE_11A_48_MBPS                 8
#define HAL_PSDU_RATE_11A_36_MBPS                 13
#define HAL_PSDU_RATE_11A_54_MBPS                 12

//MCS Index #0-15 (20MHz) Mixed Mode
#define HAL_PSDU_RATE_MCS_1NSS_MM_6_5_MBPS            0
#define HAL_PSDU_RATE_MCS_1NSS_MM_SG_7_2_MBPS         0
#define HAL_PSDU_RATE_MCS_1NSS_MM_13_MBPS             1
#define HAL_PSDU_RATE_MCS_1NSS_MM_SG_14_4_MBPS        1
#define HAL_PSDU_RATE_MCS_1NSS_MM_19_5_MBPS           2
#define HAL_PSDU_RATE_MCS_1NSS_MM_SG_21_7_MBPS        2
#define HAL_PSDU_RATE_MCS_1NSS_MM_26_MBPS             3
#define HAL_PSDU_RATE_MCS_1NSS_MM_SG_28_9_MBPS        3
#define HAL_PSDU_RATE_MCS_1NSS_MM_39_MBPS             4
#define HAL_PSDU_RATE_MCS_1NSS_MM_SG_43_3_MBPS        4
#define HAL_PSDU_RATE_MCS_1NSS_MM_52_MBPS             5
#define HAL_PSDU_RATE_MCS_1NSS_MM_SG_57_8_MBPS        5
#define HAL_PSDU_RATE_MCS_1NSS_MM_58_5_MBPS           6
#define HAL_PSDU_RATE_MCS_1NSS_MM_SG_65_MBPS          6
#define HAL_PSDU_RATE_MCS_1NSS_MM_65_MBPS             7
#define HAL_PSDU_RATE_MCS_1NSS_MM_SG_72_2_MBPS        7
#define HAL_PSDU_RATE_11AC_MCS_8			          8
#define HAL_PSDU_RATE_11AC_MCS_9			          9

#define HAL_PSDU_RATE_11B_4T_1_MBPS                  4
#define HAL_PSDU_RATE_11B_4T_2_MBPS                  8
#define HAL_PSDU_RATE_11B_4T_5_5_MBPS                22
#define HAL_PSDU_RATE_11B_4T_11_MBPS                 44

//MCS Index #0-31 (20MHz)                             //NDBPS
#define HAL_PSDU_RATE_20MHZ_MCS_IND_0_NDBPS            26
#define HAL_PSDU_RATE_20MHZ_MCS_IND_1_NDBPS            52
#define HAL_PSDU_RATE_20MHZ_MCS_IND_2_NDBPS            78
#define HAL_PSDU_RATE_20MHZ_MCS_IND_3_NDBPS            104
#define HAL_PSDU_RATE_20MHZ_MCS_IND_4_NDBPS            156
#define HAL_PSDU_RATE_20MHZ_MCS_IND_5_NDBPS            208
#define HAL_PSDU_RATE_20MHZ_MCS_IND_6_NDBPS            234
#define HAL_PSDU_RATE_20MHZ_MCS_IND_7_NDBPS            260
#define HAL_PSDU_RATE_20MHZ_MCS_IND_8_NDBPS            312

//Spica_Virgo 11A Rates                         //4 Times rate
#define HAL_PSDU_RATE_11A_4T_48_MBPS             192
#define HAL_PSDU_RATE_11A_4T_24_MBPS             96
#define HAL_PSDU_RATE_11A_4T_12_MBPS             48
#define HAL_PSDU_RATE_11A_4T_6_5_MBPS            26
#define HAL_PSDU_RATE_11A_4T_6_MBPS              24
#define HAL_PSDU_RATE_11A_4T_54_MBPS             216
#define HAL_PSDU_RATE_11A_4T_36_MBPS             144
#define HAL_PSDU_RATE_11A_4T_18_MBPS             72
#define HAL_PSDU_RATE_11A_4T_9_MBPS              36



#endif  // _HAL_INT_PHY_H_
